diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-sleep.cc ns-3.42/examples/wireless/wifi-sleep.cc
--- ns-3.41/examples/wireless/wifi-sleep.cc	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/examples/wireless/wifi-sleep.cc	2024-05-29 15:29:46.916073000 -0700
@@ -62,6 +62,7 @@
 #include "ns3/yans-wifi-helper.h"
 
 using namespace ns3;
+using namespace ns3::energy;
 
 NS_LOG_COMPONENT_DEFINE("WifiSleep");
 
@@ -109,23 +110,23 @@
 int
 main(int argc, char* argv[])
 {
-    std::string dataRate = "1Mbps";
-    uint32_t packetSize = 1000; // bytes
-    double duration = 10.0;     // seconds
-    double initialEnergy = 7.5; // joule
-    double voltage = 3.0;       // volts
-    double txPowerStart = 0.0;  // dbm
-    double txPowerEnd = 15.0;   // dbm
-    uint32_t nTxPowerLevels = 16;
-    uint32_t txPowerLevel = 0;
-    double idleCurrent = 0.273; // Ampere
-    double txCurrent = 0.380;   // Ampere
-    bool verbose = false;
+    DataRate dataRate{"1Mb/s"};
+    uint32_t packetSize{1000}; // bytes
+    Time duration{"10s"};
+    double initialEnergy{7.5}; // joule
+    double voltage{3.0};       // volts
+    double txPowerStart{0.0};  // dbm
+    double txPowerEnd{15.0};   // dbm
+    uint32_t nTxPowerLevels{16};
+    uint32_t txPowerLevel{0};
+    double idleCurrent{0.273}; // Ampere
+    double txCurrent{0.380};   // Ampere
+    bool verbose{false};
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("dataRate", "Data rate", dataRate);
     cmd.AddValue("packetSize", "size of application packet sent", packetSize);
-    cmd.AddValue("duration", "duration (seconds) of the experiment", duration);
+    cmd.AddValue("duration", "duration of the experiment", duration);
     cmd.AddValue("initialEnergy", "Initial Energy (Joule) of each node", initialEnergy);
     cmd.AddValue("voltage", "Supply voltage (Joule)", voltage);
     cmd.AddValue("txPowerStart", "Minimum available transmission level (dbm)", txPowerStart);
@@ -196,13 +197,13 @@
     apps = onOff.Install(c.Get(0));
 
     apps.Start(Seconds(0.01));
-    apps.Stop(Seconds(duration));
+    apps.Stop(duration);
 
     // Create a packet sink to receive these packets
     PacketSinkHelper sink(transportProto, InetSocketAddress(Ipv4Address::GetAny(), 9001));
     apps = sink.Install(c.Get(1));
     apps.Start(Seconds(0.01));
-    apps.Stop(Seconds(duration));
+    apps.Stop(duration);
 
     // Energy sources
     EnergySourceContainer eSources;
@@ -255,7 +256,7 @@
     Config::Connect("/NodeList/0/DeviceList/*/Phy/State/State", MakeCallback(&PhyStateTrace<0>));
     Config::Connect("/NodeList/1/DeviceList/*/Phy/State/State", MakeCallback(&PhyStateTrace<1>));
 
-    Simulator::Stop(Seconds(duration + 1));
+    Simulator::Stop(duration + Seconds(1.0));
 
     Simulator::Run();
     Simulator::Destroy();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-spatial-reuse.cc ns-3.42/examples/wireless/wifi-spatial-reuse.cc
--- ns-3.41/examples/wireless/wifi-spatial-reuse.cc	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/examples/wireless/wifi-spatial-reuse.cc	2024-05-29 15:29:46.916073000 -0700
@@ -79,7 +79,7 @@
 //  thus increasing the amount of generated traffic by setting the
 //  interval argument to a lower value is necessary to see the
 //  benefits of spatial reuse in this scenario. This can, for
-//  instance, be accomplished by setting --interval=0.0001.
+//  instance, be accomplished by setting --interval=100us.
 //
 //  Spatial reuse reset events are traced in two text files:
 //  - wifi-spatial-reuse-resets-bss-1.txt (for STA 1)
@@ -156,29 +156,29 @@
 int
 main(int argc, char* argv[])
 {
-    double duration = 10.0;      // seconds
-    double d1 = 30.0;            // meters
-    double d2 = 30.0;            // meters
-    double d3 = 150.0;           // meters
-    double powSta1 = 10.0;       // dBm
-    double powSta2 = 10.0;       // dBm
-    double powAp1 = 21.0;        // dBm
-    double powAp2 = 21.0;        // dBm
-    double ccaEdTrSta1 = -62;    // dBm
-    double ccaEdTrSta2 = -62;    // dBm
-    double ccaEdTrAp1 = -62;     // dBm
-    double ccaEdTrAp2 = -62;     // dBm
-    double minimumRssi = -82;    // dBm
-    int channelWidth = 20;       // MHz
-    uint32_t payloadSize = 1500; // bytes
-    uint32_t mcs = 0;            // MCS value
-    double interval = 0.001;     // seconds
-    bool enableObssPd = true;
-    double obssPdThreshold = -72.0; // dBm
+    Time duration{"10s"};
+    double d1{30.0};            // meters
+    double d2{30.0};            // meters
+    double d3{150.0};           // meters
+    double powSta1{10.0};       // dBm
+    double powSta2{10.0};       // dBm
+    double powAp1{21.0};        // dBm
+    double powAp2{21.0};        // dBm
+    double ccaEdTrSta1{-62};    // dBm
+    double ccaEdTrSta2{-62};    // dBm
+    double ccaEdTrAp1{-62};     // dBm
+    double ccaEdTrAp2{-62};     // dBm
+    double minimumRssi{-82};    // dBm
+    int channelWidth{20};       // MHz
+    uint32_t payloadSize{1500}; // bytes
+    uint32_t mcs{0};            // MCS value
+    Time interval{"1ms"};
+    bool enableObssPd{true};
+    double obssPdThreshold{-72.0}; // dBm
 
     CommandLine cmd(__FILE__);
-    cmd.AddValue("duration", "Duration of simulation (s)", duration);
-    cmd.AddValue("interval", "Inter packet interval (s)", interval);
+    cmd.AddValue("duration", "Duration of simulation", duration);
+    cmd.AddValue("interval", "Inter packet interval", interval);
     cmd.AddValue("enableObssPd", "Enable/disable OBSS_PD", enableObssPd);
     cmd.AddValue("d1", "Distance between STA1 and AP1 (m)", d1);
     cmd.AddValue("d2", "Distance between STA2 and AP2 (m)", d2);
@@ -330,7 +330,7 @@
         wifiStaNodes.Get(0)->AddApplication(client);
         client->SetAttribute("PacketSize", UintegerValue(payloadSize));
         client->SetAttribute("MaxPackets", UintegerValue(0));
-        client->SetAttribute("Interval", TimeValue(Seconds(interval)));
+        client->SetAttribute("Interval", TimeValue(interval));
         Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer>();
         server->SetLocal(socketAddr);
         wifiApNodes.Get(0)->AddApplication(server);
@@ -347,7 +347,7 @@
         wifiStaNodes.Get(1)->AddApplication(client);
         client->SetAttribute("PacketSize", UintegerValue(payloadSize));
         client->SetAttribute("MaxPackets", UintegerValue(0));
-        client->SetAttribute("Interval", TimeValue(Seconds(interval)));
+        client->SetAttribute("Interval", TimeValue(interval));
         Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer>();
         server->SetLocal(socketAddr);
         wifiApNodes.Get(1)->AddApplication(server);
@@ -368,14 +368,14 @@
     // Pass in the context string "2" to allow the trace to distinguish objects
     hePhyB->GetObssPdAlgorithm()->TraceConnect("Reset", "2", MakeCallback(&ResetTrace));
 
-    Simulator::Stop(Seconds(duration));
+    Simulator::Stop(duration);
     Simulator::Run();
 
     Simulator::Destroy();
 
     for (uint32_t i = 0; i < 2; i++)
     {
-        double throughput = static_cast<double>(bytesReceived[2 + i]) * 8 / 1000 / 1000 / duration;
+        const auto throughput = bytesReceived[2 + i] * 8.0 / duration.GetMicroSeconds();
         std::cout << "Throughput for BSS " << i + 1 << ": " << throughput << " Mbit/s" << std::endl;
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-spectrum-per-example.cc ns-3.42/examples/wireless/wifi-spectrum-per-example.cc
--- ns-3.41/examples/wireless/wifi-spectrum-per-example.cc	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/examples/wireless/wifi-spectrum-per-example.cc	2024-05-29 15:29:46.916073000 -0700
@@ -64,7 +64,7 @@
 // Users may vary the following command-line arguments in addition to the
 // attributes, global values, and default values typically available:
 //
-//    --simulationTime:  Simulation time in seconds [10]
+//    --simulationTime:  Simulation time [10s]
 //    --udp:             UDP if set to 1, TCP otherwise [true]
 //    --distance:        meters separation between nodes [50]
 //    --index:           restrict index to single value between 0 and 31 [256]
@@ -128,17 +128,17 @@
 int
 main(int argc, char* argv[])
 {
-    bool udp = true;
-    double distance = 50;
-    double simulationTime = 10; // seconds
-    uint16_t index = 256;
-    std::string wifiType = "ns3::SpectrumWifiPhy";
-    std::string errorModelType = "ns3::NistErrorRateModel";
-    bool enablePcap = false;
-    const uint32_t tcpPacketSize = 1448;
+    bool udp{true};
+    double distance{50};
+    Time simulationTime{"10s"};
+    uint16_t index{256};
+    std::string wifiType{"ns3::SpectrumWifiPhy"};
+    std::string errorModelType{"ns3::NistErrorRateModel"};
+    bool enablePcap{false};
+    const uint32_t tcpPacketSize{1448};
 
     CommandLine cmd(__FILE__);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("udp", "UDP if set to 1, TCP otherwise", udp);
     cmd.AddValue("distance", "meters separation between nodes", distance);
     cmd.AddValue("index", "restrict index to single value between 0 and 31", index);
@@ -413,30 +413,10 @@
             apDevice = wifi.Install(spectrumPhy, mac, wifiApNode);
         }
 
-        if (i <= 7)
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(false));
-        }
-        else if (i > 7 && i <= 15)
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(true));
-        }
-        else if (i > 15 && i <= 23)
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(false));
-        }
-        else
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(true));
-        }
+        bool shortGuardIntervalSupported = (i > 7 && i <= 15) || (i > 23);
+        Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
+                    "ShortGuardIntervalSupported",
+                    BooleanValue(shortGuardIntervalSupported));
 
         // mobility.
         MobilityHelper mobility;
@@ -473,15 +453,16 @@
             UdpServerHelper server(port);
             serverApp = server.Install(wifiStaNode.Get(0));
             serverApp.Start(Seconds(0.0));
-            serverApp.Stop(Seconds(simulationTime + 1));
+            serverApp.Stop(simulationTime + Seconds(1.0));
+            const auto packetInterval = payloadSize * 8.0 / (datarate * 1e6);
 
             UdpClientHelper client(staNodeInterface.GetAddress(0), port);
             client.SetAttribute("MaxPackets", UintegerValue(4294967295U));
-            client.SetAttribute("Interval", TimeValue(Time("0.0001"))); // packets/s
+            client.SetAttribute("Interval", TimeValue(Seconds(packetInterval)));
             client.SetAttribute("PacketSize", UintegerValue(payloadSize));
             ApplicationContainer clientApp = client.Install(wifiApNode.Get(0));
             clientApp.Start(Seconds(1.0));
-            clientApp.Stop(Seconds(simulationTime + 1));
+            clientApp.Stop(simulationTime + Seconds(1.0));
         }
         else
         {
@@ -491,18 +472,18 @@
             PacketSinkHelper packetSinkHelper("ns3::TcpSocketFactory", localAddress);
             serverApp = packetSinkHelper.Install(wifiStaNode.Get(0));
             serverApp.Start(Seconds(0.0));
-            serverApp.Stop(Seconds(simulationTime + 1));
+            serverApp.Stop(simulationTime + Seconds(1.0));
 
             OnOffHelper onoff("ns3::TcpSocketFactory", Ipv4Address::GetAny());
             onoff.SetAttribute("OnTime", StringValue("ns3::ConstantRandomVariable[Constant=1]"));
             onoff.SetAttribute("OffTime", StringValue("ns3::ConstantRandomVariable[Constant=0]"));
             onoff.SetAttribute("PacketSize", UintegerValue(payloadSize));
-            onoff.SetAttribute("DataRate", DataRateValue(1000000000)); // bit/s
+            onoff.SetAttribute("DataRate", DataRateValue(datarate * 1e6));
             AddressValue remoteAddress(InetSocketAddress(staNodeInterface.GetAddress(0), port));
             onoff.SetAttribute("Remote", remoteAddress);
             ApplicationContainer clientApp = onoff.Install(wifiApNode.Get(0));
             clientApp.Start(Seconds(1.0));
-            clientApp.Stop(Seconds(simulationTime + 1));
+            clientApp.Stop(simulationTime + Seconds(1.0));
         }
 
         Config::ConnectWithoutContext("/NodeList/0/DeviceList/*/Phy/MonitorSnifferRx",
@@ -519,24 +500,24 @@
         g_noiseDbmAvg = 0;
         g_samples = 0;
 
-        Simulator::Stop(Seconds(simulationTime + 1));
+        Simulator::Stop(simulationTime + Seconds(1.0));
         Simulator::Run();
 
-        double throughput = 0;
-        uint64_t totalPacketsThrough = 0;
+        auto throughput = 0.0;
+        auto totalPacketsThrough = 0.0;
         if (udp)
         {
             // UDP
             totalPacketsThrough = DynamicCast<UdpServer>(serverApp.Get(0))->GetReceived();
             throughput =
-                totalPacketsThrough * payloadSize * 8 / (simulationTime * 1000000.0); // Mbit/s
+                totalPacketsThrough * payloadSize * 8 / simulationTime.GetMicroSeconds(); // Mbit/s
         }
         else
         {
             // TCP
-            uint64_t totalBytesRx = DynamicCast<PacketSink>(serverApp.Get(0))->GetTotalRx();
+            auto totalBytesRx = DynamicCast<PacketSink>(serverApp.Get(0))->GetTotalRx();
             totalPacketsThrough = totalBytesRx / tcpPacketSize;
-            throughput = totalBytesRx * 8 / (simulationTime * 1000000.0); // Mbit/s
+            throughput = totalBytesRx * 8 / simulationTime.GetMicroSeconds(); // Mbit/s
         }
         std::cout << std::setw(5) << i << std::setw(6) << (i % 8) << std::setprecision(2)
                   << std::fixed << std::setw(10) << datarate << std::setw(12) << throughput
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-spectrum-per-interference.cc ns-3.42/examples/wireless/wifi-spectrum-per-interference.cc
--- ns-3.41/examples/wireless/wifi-spectrum-per-interference.cc	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/examples/wireless/wifi-spectrum-per-interference.cc	2024-05-29 15:29:46.916073000 -0700
@@ -69,7 +69,7 @@
 // Users may vary the following command-line arguments in addition to the
 // attributes, global values, and default values typically available:
 //
-//    --simulationTime:  Simulation time in seconds [10]
+//    --simulationTime:  Simulation time [10s]
 //    --udp:             UDP if set to 1, TCP otherwise [true]
 //    --distance:        meters separation between nodes [50]
 //    --index:           restrict index to single value between 0 and 31 [256]
@@ -179,18 +179,18 @@
 int
 main(int argc, char* argv[])
 {
-    bool udp = true;
-    double distance = 50;
-    double simulationTime = 10; // seconds
-    uint16_t index = 256;
-    std::string wifiType = "ns3::SpectrumWifiPhy";
-    std::string errorModelType = "ns3::NistErrorRateModel";
-    bool enablePcap = false;
-    const uint32_t tcpPacketSize = 1448;
-    double waveformPower = 0;
+    bool udp{true};
+    double distance{50};
+    Time simulationTime{"10s"};
+    uint16_t index{256};
+    std::string wifiType{"ns3::SpectrumWifiPhy"};
+    std::string errorModelType{"ns3::NistErrorRateModel"};
+    bool enablePcap{false};
+    const uint32_t tcpPacketSize{1448};
+    double waveformPower{0};
 
     CommandLine cmd(__FILE__);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("udp", "UDP if set to 1, TCP otherwise", udp);
     cmd.AddValue("distance", "meters separation between nodes", distance);
     cmd.AddValue("index", "restrict index to single value between 0 and 31", index);
@@ -468,30 +468,10 @@
             apDevice = wifi.Install(spectrumPhy, mac, wifiApNode);
         }
 
-        if (i <= 7)
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(false));
-        }
-        else if (i > 7 && i <= 15)
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(true));
-        }
-        else if (i > 15 && i <= 23)
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(false));
-        }
-        else
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(true));
-        }
+        bool shortGuardIntervalSupported = (i > 7 && i <= 15) || (i > 23);
+        Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
+                    "ShortGuardIntervalSupported",
+                    BooleanValue(shortGuardIntervalSupported));
 
         // mobility.
         MobilityHelper mobility;
@@ -530,15 +510,16 @@
             UdpServerHelper server(port);
             serverApp = server.Install(wifiStaNode.Get(0));
             serverApp.Start(Seconds(0.0));
-            serverApp.Stop(Seconds(simulationTime + 1));
+            serverApp.Stop(simulationTime + Seconds(1.0));
+            const auto packetInterval = payloadSize * 8.0 / (datarate * 1e6);
 
             UdpClientHelper client(staNodeInterface.GetAddress(0), port);
             client.SetAttribute("MaxPackets", UintegerValue(4294967295U));
-            client.SetAttribute("Interval", TimeValue(Time("0.0001"))); // packets/s
+            client.SetAttribute("Interval", TimeValue(Seconds(packetInterval)));
             client.SetAttribute("PacketSize", UintegerValue(payloadSize));
             ApplicationContainer clientApp = client.Install(wifiApNode.Get(0));
             clientApp.Start(Seconds(1.0));
-            clientApp.Stop(Seconds(simulationTime + 1));
+            clientApp.Stop(simulationTime + Seconds(1.0));
         }
         else
         {
@@ -548,18 +529,18 @@
             PacketSinkHelper packetSinkHelper("ns3::TcpSocketFactory", localAddress);
             serverApp = packetSinkHelper.Install(wifiStaNode.Get(0));
             serverApp.Start(Seconds(0.0));
-            serverApp.Stop(Seconds(simulationTime + 1));
+            serverApp.Stop(simulationTime + Seconds(1.0));
 
             OnOffHelper onoff("ns3::TcpSocketFactory", Ipv4Address::GetAny());
             onoff.SetAttribute("OnTime", StringValue("ns3::ConstantRandomVariable[Constant=1]"));
             onoff.SetAttribute("OffTime", StringValue("ns3::ConstantRandomVariable[Constant=0]"));
             onoff.SetAttribute("PacketSize", UintegerValue(payloadSize));
-            onoff.SetAttribute("DataRate", DataRateValue(1000000000)); // bit/s
+            onoff.SetAttribute("DataRate", DataRateValue(datarate * 1e6));
             AddressValue remoteAddress(InetSocketAddress(staNodeInterface.GetAddress(0), port));
             onoff.SetAttribute("Remote", remoteAddress);
             ApplicationContainer clientApp = onoff.Install(wifiApNode.Get(0));
             clientApp.Start(Seconds(1.0));
-            clientApp.Stop(Seconds(simulationTime + 1));
+            clientApp.Stop(simulationTime + Seconds(1.0));
         }
 
         // Configure waveform generator
@@ -623,24 +604,24 @@
                 "Error:  Wi-Fi nodes must be tuned to 5190 MHz to match the waveform generator");
         }
 
-        Simulator::Stop(Seconds(simulationTime + 1));
+        Simulator::Stop(simulationTime + Seconds(1.0));
         Simulator::Run();
 
-        double throughput = 0;
-        uint64_t totalPacketsThrough = 0;
+        auto throughput = 0.0;
+        auto totalPacketsThrough = 0.0;
         if (udp)
         {
             // UDP
             totalPacketsThrough = DynamicCast<UdpServer>(serverApp.Get(0))->GetReceived();
             throughput =
-                totalPacketsThrough * payloadSize * 8 / (simulationTime * 1000000.0); // Mbit/s
+                totalPacketsThrough * payloadSize * 8 / simulationTime.GetMicroSeconds(); // Mbit/s
         }
         else
         {
             // TCP
-            uint64_t totalBytesRx = DynamicCast<PacketSink>(serverApp.Get(0))->GetTotalRx();
+            auto totalBytesRx = DynamicCast<PacketSink>(serverApp.Get(0))->GetTotalRx();
             totalPacketsThrough = totalBytesRx / tcpPacketSize;
-            throughput = totalBytesRx * 8 / (simulationTime * 1000000.0); // Mbit/s
+            throughput = totalBytesRx * 8 / simulationTime.GetMicroSeconds(); // Mbit/s
         }
         std::cout << std::setw(5) << i << std::setw(6) << (i % 8) << std::setprecision(2)
                   << std::fixed << std::setw(10) << datarate << std::setw(12) << throughput
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-spectrum-saturation-example.cc ns-3.42/examples/wireless/wifi-spectrum-saturation-example.cc
--- ns-3.41/examples/wireless/wifi-spectrum-saturation-example.cc	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/examples/wireless/wifi-spectrum-saturation-example.cc	2024-05-29 15:29:46.916073000 -0700
@@ -60,7 +60,7 @@
 // Users may vary the following command-line arguments in addition to the
 // attributes, global values, and default values typically available:
 //
-//    --simulationTime:  Simulation time in seconds [10]
+//    --simulationTime:  Simulation time [10s]
 //    --distance:        meters separation between nodes [1]
 //    --index:           restrict index to single value between 0 and 31 [256]
 //    --wifiType:        select ns3::SpectrumWifiPhy or ns3::YansWifiPhy [ns3::SpectrumWifiPhy]
@@ -100,16 +100,16 @@
 int
 main(int argc, char* argv[])
 {
-    double distance = 1;
-    double simulationTime = 10; // seconds
-    uint16_t index = 256;
-    uint32_t channelWidth = 0;
-    std::string wifiType = "ns3::SpectrumWifiPhy";
-    std::string errorModelType = "ns3::NistErrorRateModel";
-    bool enablePcap = false;
+    double distance{1};
+    Time simulationTime{"10s"};
+    uint16_t index{256};
+    uint32_t channelWidth{0};
+    std::string wifiType{"ns3::SpectrumWifiPhy"};
+    std::string errorModelType{"ns3::NistErrorRateModel"};
+    bool enablePcap{false};
 
     CommandLine cmd(__FILE__);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("distance", "meters separation between nodes", distance);
     cmd.AddValue("index", "restrict index to single value between 0 and 63", index);
     cmd.AddValue("wifiType", "select ns3::SpectrumWifiPhy or ns3::YansWifiPhy", wifiType);
@@ -152,25 +152,7 @@
             phy.Set("TxPowerStart", DoubleValue(1));
             phy.Set("TxPowerEnd", DoubleValue(1));
 
-            if (i > 31 && i <= 39)
-            {
-                phy.Set("Antennas", UintegerValue(2));
-                phy.Set("MaxSupportedTxSpatialStreams", UintegerValue(2));
-                phy.Set("MaxSupportedRxSpatialStreams", UintegerValue(2));
-            }
-            else if (i > 39 && i <= 47)
-            {
-                phy.Set("Antennas", UintegerValue(2));
-                phy.Set("MaxSupportedTxSpatialStreams", UintegerValue(2));
-                phy.Set("MaxSupportedRxSpatialStreams", UintegerValue(2));
-            }
-            else if (i > 47 && i <= 55)
-            {
-                phy.Set("Antennas", UintegerValue(2));
-                phy.Set("MaxSupportedTxSpatialStreams", UintegerValue(2));
-                phy.Set("MaxSupportedRxSpatialStreams", UintegerValue(2));
-            }
-            else if (i > 55 && i <= 63)
+            if (i > 31 && i <= 63)
             {
                 phy.Set("Antennas", UintegerValue(2));
                 phy.Set("MaxSupportedTxSpatialStreams", UintegerValue(2));
@@ -193,25 +175,7 @@
             spectrumPhy.Set("TxPowerStart", DoubleValue(1));
             spectrumPhy.Set("TxPowerEnd", DoubleValue(1));
 
-            if (i > 31 && i <= 39)
-            {
-                spectrumPhy.Set("Antennas", UintegerValue(2));
-                spectrumPhy.Set("MaxSupportedTxSpatialStreams", UintegerValue(2));
-                spectrumPhy.Set("MaxSupportedRxSpatialStreams", UintegerValue(2));
-            }
-            else if (i > 39 && i <= 47)
-            {
-                spectrumPhy.Set("Antennas", UintegerValue(2));
-                spectrumPhy.Set("MaxSupportedTxSpatialStreams", UintegerValue(2));
-                spectrumPhy.Set("MaxSupportedRxSpatialStreams", UintegerValue(2));
-            }
-            else if (i > 47 && i <= 55)
-            {
-                spectrumPhy.Set("Antennas", UintegerValue(2));
-                spectrumPhy.Set("MaxSupportedTxSpatialStreams", UintegerValue(2));
-                spectrumPhy.Set("MaxSupportedRxSpatialStreams", UintegerValue(2));
-            }
-            else if (i > 55 && i <= 63)
+            if (i > 31 && i <= 63)
             {
                 spectrumPhy.Set("Antennas", UintegerValue(2));
                 spectrumPhy.Set("MaxSupportedTxSpatialStreams", UintegerValue(2));
@@ -588,30 +552,11 @@
             apDevice = wifi.Install(spectrumPhy, mac, wifiApNode);
         }
 
-        if ((i <= 7) || (i > 31 && i <= 39))
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(false));
-        }
-        else if ((i > 7 && i <= 15) || (i > 39 && i <= 47))
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(true));
-        }
-        else if ((i > 15 && i <= 23) || (i > 47 && i <= 55))
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(false));
-        }
-        else
-        {
-            Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
-                        "ShortGuardIntervalSupported",
-                        BooleanValue(true));
-        }
+        bool shortGuardIntervalSupported =
+            (i > 7 && i <= 15) || (i > 23 && i <= 31) || (i > 39 && i <= 47) || (i > 55);
+        Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/"
+                    "ShortGuardIntervalSupported",
+                    BooleanValue(shortGuardIntervalSupported));
 
         // mobility.
         MobilityHelper mobility;
@@ -644,15 +589,16 @@
         UdpServerHelper server(port);
         ApplicationContainer serverApp = server.Install(wifiStaNode.Get(0));
         serverApp.Start(Seconds(0.0));
-        serverApp.Stop(Seconds(simulationTime + 1));
+        serverApp.Stop(simulationTime + Seconds(1.0));
+        const auto packetInterval = payloadSize * 8.0 / (datarate * 1e6);
 
         UdpClientHelper client(staNodeInterface.GetAddress(0), port);
         client.SetAttribute("MaxPackets", UintegerValue(4294967295U));
-        client.SetAttribute("Interval", TimeValue(Time("0.0001"))); // packets/s
+        client.SetAttribute("Interval", TimeValue(Seconds(packetInterval)));
         client.SetAttribute("PacketSize", UintegerValue(payloadSize));
         ApplicationContainer clientApp = client.Install(wifiApNode.Get(0));
         clientApp.Start(Seconds(1.0));
-        clientApp.Stop(Seconds(simulationTime + 1));
+        clientApp.Stop(simulationTime + Seconds(1.0));
 
         if (enablePcap)
         {
@@ -662,13 +608,12 @@
             phy.EnablePcap(ss.str(), apDevice);
         }
 
-        Simulator::Stop(Seconds(simulationTime + 1));
+        Simulator::Stop(simulationTime + Seconds(1.0));
         Simulator::Run();
 
-        double throughput;
-        uint64_t totalPacketsThrough;
-        totalPacketsThrough = DynamicCast<UdpServer>(serverApp.Get(0))->GetReceived();
-        throughput = totalPacketsThrough * payloadSize * 8 / (simulationTime * 1000000.0); // Mbit/s
+        double totalPacketsThrough = DynamicCast<UdpServer>(serverApp.Get(0))->GetReceived();
+        auto throughput =
+            totalPacketsThrough * payloadSize * 8 / simulationTime.GetMicroSeconds(); // Mbit/s
         std::cout << std::setw(5) << i << std::setw(6) << (i % 8) + 8 * (i / 32) << std::setw(8)
                   << channelWidth << std::setw(10) << datarate << std::setw(12) << throughput
                   << std::setw(8) << totalPacketsThrough << std::endl;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-tcp.cc ns-3.42/examples/wireless/wifi-tcp.cc
--- ns-3.41/examples/wireless/wifi-tcp.cc	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/examples/wireless/wifi-tcp.cc	2024-05-29 15:29:46.916073000 -0700
@@ -72,12 +72,12 @@
 int
 main(int argc, char* argv[])
 {
-    uint32_t payloadSize = 1472;           /* Transport layer payload size in bytes. */
-    std::string dataRate = "100Mbps";      /* Application layer datarate. */
-    std::string tcpVariant = "TcpNewReno"; /* TCP variant type. */
-    std::string phyRate = "HtMcs7";        /* Physical layer bitrate. */
-    double simulationTime = 10;            /* Simulation time in seconds. */
-    bool pcapTracing = false;              /* PCAP Tracing is enabled or not. */
+    uint32_t payloadSize{1472};           /* Transport layer payload size in bytes. */
+    DataRate dataRate{"100Mb/s"};         /* Application layer datarate. */
+    std::string tcpVariant{"TcpNewReno"}; /* TCP variant type. */
+    std::string phyRate{"HtMcs7"};        /* Physical layer bitrate. */
+    Time simulationTime{"10s"};           /* Simulation time. */
+    bool pcapTracing{false};              /* PCAP Tracing is enabled or not. */
 
     /* Command line argument parser setup. */
     CommandLine cmd(__FILE__);
@@ -194,10 +194,11 @@
     }
 
     /* Start Simulation */
-    Simulator::Stop(Seconds(simulationTime + 1));
+    Simulator::Stop(simulationTime + Seconds(1.0));
     Simulator::Run();
 
-    double averageThroughput = ((sink->GetTotalRx() * 8) / (1e6 * simulationTime));
+    auto averageThroughput =
+        (static_cast<double>(sink->GetTotalRx() * 8) / simulationTime.GetMicroSeconds());
 
     Simulator::Destroy();
 
